# Testplattform for utviklerkandidater 

Laget av \
Anders-Marius Gjerdalen \
Anine Hammersborg \
Birk Johannessen  

 

Dataingeniør \
Fakultet for ingeniør- og naturvitskap(FIN) \
Institutt for datateknologi, elektroteknologi og realfag

Veileder \
Voilet Ka I Pun

Oppdragsgiver \
Wide Assessment


## DEPENDENCY STACK
MSSQL server - Used by hangfire \
POSTGRESQL server - Used by Entity Framework \
DOTNET 7.0 SDK+RUNTIME \
NPM 18.0

### LINUX setup:

Building the database
```
cd testplatform-backend/api 
dotnet ef database update
```

Start backend:
```
cd testplatform-backend/api 
dotnet build
```

start frontend:
```
cd testplatform-frontend 
npm i 
npm start
```

Requires docker for MSSQL: [Official Microsoft guide](https://learn.microsoft.com/en-us/sql/linux/quickstart-install-connect-docker?view=sql-server-ver16)
```
sudo docker pull mcr.microsoft.com/mssql/server:2022-latest 
sudo docker run -e "ACCEPT_EULA=Y" -e "MSSQL_SA_PASSWORD=YourStrong@Passw0rd" \
   -p 1433:1433 --name sql1 --hostname sql1 \
   -d \
   mcr.microsoft.com/mssql/server:2022-latest 

sudo docker ps -a
```

## Screendumps

Images of the application

### Set a name & Home page
The application has no login or authentication system. This was part of the development plan as the client of the project has their own system that they can integrate themselves. The database needs a name to save all the tests under, so the given input works like a login.
![alt text](https://github.com/BirkJohannessen/testplatform/blob/main/assets/setname.png)

The default homepage with ChatGPT generated welcome message.

![alt text](https://github.com/BirkJohannessen/testplatform/blob/main/assets/home.png)

### Overview of the test that the user can complete.

After navigating the header to the </> (code) section.\
This will display the current users progress. the user we named earlier has no test progressed or completed.

![alt text](https://github.com/BirkJohannessen/testplatform/blob/main/assets/filter-default.png)

example of filter in use.

![alt text](https://github.com/BirkJohannessen/testplatform/blob/main/assets/filter-example.png)

### Solving a test

After the user selects a test he is welcomed with startcode, a description and some public unittests

![alt text](https://github.com/BirkJohannessen/testplatform/blob/main/assets/assignment-default.png)

The user writes some code. this code is obviously wrong. \
The user presses the Run button aswell. while the code is compiling the button is signifying that the application is processing the request.

![alt text](https://github.com/BirkJohannessen/testplatform/blob/main/assets/assignment-loading.png)

The request has been handeled and the response is displayed in the Output tab.

![alt text](https://github.com/BirkJohannessen/testplatform/blob/main/assets/assignment-false.png)

An example where the user writes some syntax error

![alt text](https://github.com/BirkJohannessen/testplatform/blob/main/assets/assignment-syntaxerror.png)

The user writes correct code along with the resonse from the server.

![alt text](https://github.com/BirkJohannessen/testplatform/blob/main/assets/assignment-true.png)

### Finishing up ...

After pressing the save button next to the run button, the progressbar of the completed task Return True is green.

![alt text](https://github.com/BirkJohannessen/testplatform/blob/main/assets/filter-complete.png)

