using Microsoft.AspNetCore.Mvc;
using Hangfire;
using response;
using context;
using helper;
using models;
using request;


[ApiController]
[Route("api/[controller]")]
public class ResultController : ControllerBase
{
    private readonly ILogger<ResultController> _logger;
    private readonly TestPlatformResponse _response;
    public ResultHelper _helper { get; set; }
    public ResultController(ILogger<ResultController> logger, TestPlatformContext context) {
        TestPlatformResponse response = new TestPlatformResponse();
        _helper = new ResultHelper(response, context);
        _logger = logger;
        _response = response;
    }
    [HttpGet]
    public IActionResult results() {
        try {
            return Ok(_helper.getResults());
        } catch (Exception)
        {
            _response.error = "unhandled exception.";
            _response.data = null;
            _response.status = Status.Failed;
            return NotFound(_response);
        }
    }
    [HttpDelete("{id}")]
    public IActionResult deleteResult(int id) {
        try {
            return Ok(_helper.deleteResult(id));
        }
        catch (Exception) {
            _response.error = "unhandled exception.";
            _response.data = null;
            _response.status = Status.Failed;
            return NotFound(_response);
        }
    }
    [HttpGet("{id}")]
    public IActionResult result(int id) {
        try {
            return Ok(_helper.getSingleResult(id));
        } catch (Exception) {
            _response.error = "unhandled exception.";
            _response.data = null;
            _response.status = Status.Failed;
            return NotFound(_response);
        }
    }
}