using Microsoft.AspNetCore.Mvc;
using request;
using models;
using response;
using context;
using helper;

[ApiController]
[Route("api/[controller]")]
public class TestController : ControllerBase {
    private readonly ILogger<TestController> _logger;
    private readonly TestPlatformResponse _response;
    public TestHelper _helper { get ; set ; }
    public TestController(ILogger<TestController> logger, TestPlatformContext context) {
        TestPlatformResponse response = new TestPlatformResponse();
        _helper = new TestHelper(response, context);
        _logger = logger;
        _response = response;
    }
    [HttpGet]
    public IActionResult tests() {
        try{
            return Ok(_helper.getAllTests());
        }catch(Exception){
            _response.error = "unhandled exception.";
            _response.data = null;
            _response.status = Status.Failed;
            return NotFound(_response);
        }
    }
    [HttpPost]
    public IActionResult newTest(TestRequest testRequest) {
        try{
            return Ok(_helper.newTest(testRequest));
        }catch(Exception){
            _response.error = "unhandled exception.";
            _response.data = null;
            _response.status = Status.Failed;
            return NotFound(_response);
        }
    }
    [HttpDelete("{id}")]
    public IActionResult deleteTest(int id) {
        try{
            return Ok(_helper.deleteTest(id));
        }catch(Exception){
            _response.error = "unhandled exception.";
            _response.data = null;
            _response.status = Status.Failed;
            return NotFound(_response);
        }
    }
    [HttpGet("{id}")]
    public IActionResult test(int id) {
        try{
            return Ok(_helper.getSingleTest(id));
        }catch(Exception){
            _response.error = "unhandled exception.";
            _response.data = null;
            _response.status = Status.Failed;
            return NotFound(_response);
        }
    }
}