using Microsoft.EntityFrameworkCore;
namespace services;
using context;
using models;
using executionenv;
using Hangfire;

public class CodeExecService{
    private TestPlatformContext _context { get; set; }
    private Attempt _attempt { get; set; }
    public IBackgroundJobClient _backgroundJobClient { get; set; }
    public string _connectionId { get; set; }
    public CodeExecService( TestPlatformContext context, Attempt attempt, IBackgroundJobClient backgroundJobClient, string connectionId){
        _backgroundJobClient = backgroundJobClient;
        _context = context;
        _attempt = attempt;
        _connectionId = connectionId;
    }

    public void calculateResult(){
        Attempt attemptEager = null;
        try{
            attemptEager = _context.tbl_attempt
            .Include( a => a.languageVersion)
            .ThenInclude( lv => lv.language)
            .Include( a => a.userAssignment)
            .Single(attempt => attempt.id == _attempt.id);
        }catch(Exception){
            Console.WriteLine("hei error");
            return;
        }
        switch(attemptEager.languageVersion.language.name){
            case "Javascript":
                Console.WriteLine("hei JS"+attemptEager.ToString());
                _backgroundJobClient.Enqueue<JavascriptEnv>(jse => jse.exec(attemptEager.id, _connectionId));
            break;
            case "JavaScript":
                Console.WriteLine("hei JS"+attemptEager.ToString());
                _backgroundJobClient.Enqueue<JavascriptEnv>(jse => jse.exec(attemptEager.id, _connectionId));
            break;
        }
    }
}