using System.Collections.Concurrent;
using Microsoft.AspNetCore.SignalR;
using models;
using context;
using Hangfire;
using services;
using System.Text.Json;
using helper;
using response;

namespace hubs;
public class ResultHub : Hub {
    public IBackgroundJobClient _backgroundJobClient { get; set; }
    public TestPlatformContext _context { get; set; }
    public AttemptHelper _attemptHelper { get; set; }

    public ResultHub(TestPlatformContext context, IBackgroundJobClient backgroundJobClient){
        _context = context;
        _backgroundJobClient = backgroundJobClient;
        _attemptHelper = new AttemptHelper(new TestPlatformResponse(), _context, _backgroundJobClient);
    }
        public async Task RecieveAttempt(string attemptJSON) {
            TestPlatformResponse response = new TestPlatformResponse();
            response.error = "JSON parse error";
            response.status = Status.Failed;
        try{
            Attempt attempt = JsonSerializer.Deserialize<Attempt>(attemptJSON);
            response = _attemptHelper.newAttempt(attempt, Context.ConnectionId);
            Clients.Caller.SendAsync("status", response);
        }catch(Exception){
            Clients.Caller.SendAsync("status", response);
        }
    }

    public async Task SendResult(string resultJSON, string connectionId) {
        Clients.Client(connectionId).SendAsync("result", resultJSON);
    }
}