namespace helper;
using response;
using request;
using context;
using impl;
using models;
public class AssignmentHelper{

    public TestPlatformResponse _response { get; set; }
    public DBimpl _impl { get; set; }
    public AssignmentHelper(TestPlatformResponse response, TestPlatformContext context){
        _response = response;
        _impl = new DBimpl(context);
    }

    public TestPlatformResponse getAllAssignments(){
        _response.data = _impl.getAllAssignments();
        if(_response.data == null){
          _response.error = "Something went wrong.. Maybe no tests in DB?";
          _response.status = Status.Failed;
        }else{
          _response.status = Status.Success;
        }
        return _response;
   } 
   public TestPlatformResponse newAssignment(AssignmentRequest assignmentRequest){
        if(_impl.newAssignment(assignmentRequest.convertToModelNew(_impl))){
          _response.data = true;
          _response.status = Status.Success;
        }else{
          _response.status = Status.Failed;
          _response.error = "Assignment already exists";
        }
        return _response;
   }
   public TestPlatformResponse updateAssignment(int id, AssignmentRequest assignmentRequest){
        Assignment assignment = null;
        try{
            assignment = assignmentRequest.convertToModelUpdate(_impl);
        }catch(Exception e){
            _response.status = Status.Failed;
            _response.error = "conversion faiilure";
            return _response;
        }
        if(_impl.updateAssignment(id, assignment)){
          _response.data = true;
          _response.status = Status.Success;
        }else{
          _response.status = Status.Failed;
          _response.error = "the id doesnt match for update";
        }
        return _response;
   }
   public TestPlatformResponse deleteAssignment(int assignmentID){
        //TODO restrict who can delete an assignment.
        TestPlatformResponse singleAssignmentResponse = getSingleAssignment(assignmentID);
        _response = singleAssignmentResponse;
        Assignment assignment = (Assignment) singleAssignmentResponse.data;
        if(assignment != null){
           if(_impl.deleteAssignment(assignment)){
            _response.status = Status.Success;
            _response.data = true;
			_response.error = "";
           }else{
            _response.status = Status.Failed;
            _response.error = "unknown error occured deleting id "+assignmentID;
           }
        }
        return _response;
   }
    public TestPlatformResponse getSingleAssignment(int assignmentID){
        _response.data = _impl.getSingleAssignment(assignmentID);
        if(_response.data == null){
          _response.status = Status.Failed;
          _response.error = "No match for assignmentID: " + assignmentID;
        }else{
          _response.status = Status.Success;
        }
        return _response;
   }
}