namespace helper;
using System;
using Hangfire;
using response;
using request;
using context;
using impl;
using models;
using services;
using hubs;
using System.Collections.Concurrent;
public class AttemptHelper
{

    public TestPlatformResponse _response { get; set; }
    public DBimpl _impl { get; set; }
    public TestPlatformContext _context { get; set; }
    public IBackgroundJobClient _backgroundJobClient;
    public AttemptHelper(TestPlatformResponse response, TestPlatformContext context,
     IBackgroundJobClient backgroundJobClient) {
        _response = response;
        _context = context;
        _impl = new DBimpl(context);
        _backgroundJobClient = backgroundJobClient;
    }

    public TestPlatformResponse newAttempt(Attempt attempt, string connectionId) {
        attempt = _impl.newAttempt(attempt);
        if (attempt != null) {
            _response.data = true;
			new CodeExecService(_context, attempt, _backgroundJobClient, connectionId).calculateResult();
            _response.status = Status.Success;
        }
        else {
            _response.status = Status.Failed;
            _response.error = "Attempt Has wrong foreign keys";
        }
        return _response;
    }
    public TestPlatformResponse deleteAttempt(int attemptID) {
        //TODO restrict who can delete an assignment.
        TestPlatformResponse singleAttemptResponse = getSingleAttempt(attemptID);
        _response = singleAttemptResponse;
        Attempt attempt = (Attempt)singleAttemptResponse.data;
        if (attempt != null)
        {
            if (_impl.deleteAttempt(attempt))
            {
                _response.status = Status.Success;
                _response.data = true;
                _response.error = "";
            }
            else
            {
                _response.status = Status.Failed;
                _response.error = "unknown error occured deleting id " + attemptID;
            }
        }
        return _response;
    }
    public TestPlatformResponse getSingleAttempt(int attemptID)
    {
        _response.data = _impl.getSingleAttempt(attemptID);
        if (_response.data == null)
        {
            _response.status = Status.Failed;
            _response.error = "No match for attemptID: " + attemptID;
        }
        else
        {
            _response.status = Status.Success;
        }
        return _response;
    }
}