
namespace helper;
using response;
using context;
using impl;
using models;
public class LanguageHelper{

    public TestPlatformResponse _response { get; set; }
    public DBimpl _impl { get; set; }
    public LanguageHelper(TestPlatformResponse response, TestPlatformContext context){
        _response = response;
        _impl = new DBimpl(context);
    }

    public TestPlatformResponse getAllLanguages(){
        _response.data = _impl.getAllLanguages();
        if(_response.data == null){
          _response.error = "Something went wrong.. Maybe no language in DB?";
          _response.status = Status.Failed;
        }else{
          _response.status = Status.Success;
        }
        return _response;
   } 
   public TestPlatformResponse newLanguage(Language language){
        if(_impl.newLanguage(language)){
          _response.data = true;
          _response.status = Status.Success;
        }else{
          _response.status = Status.Failed;
          _response.error = "Language already exists";
        }
        return _response;
   }
   public TestPlatformResponse deleteLanguage(int languageID){
        //TODO restrict who can delete language.
        TestPlatformResponse singleLanguageResponse = getSingleLanguage(languageID);
        _response = singleLanguageResponse;
        Language language = (Language) singleLanguageResponse.data;
        if(language != null){
           if(_impl.deleteLanguage(language)){
            _response.status = Status.Success;
            _response.data = true;
			_response.error = null;
           }else{
            _response.status = Status.Failed;
            _response.error = "unknown error occured deleting id "+languageID;
           }
        }
        return _response;
   }
    public TestPlatformResponse getSingleLanguage(int languageID){
        _response.data = _impl.getSingleLanguage(languageID);
        if(_response.data == null){
          _response.status = Status.Failed;
          _response.error = "No match for languageID: " + languageID;
        }else{
          _response.status = Status.Success;
        }
        return _response;
   }
}