namespace helper;
using response;
using context;
using impl;
using models;
using request;
public class LanguageVersionHelper{

    public TestPlatformResponse _response { get; set; }
    public DBimpl _impl { get; set; }
    public LanguageVersionHelper(TestPlatformResponse response, TestPlatformContext context){
        _response = response;
        _impl = new DBimpl(context);
    }

    public TestPlatformResponse getAllLanguageVersions(){
        _response.data = _impl.getAllLanguageVersions();
        if(_response.data == null){
          _response.error = "Something went wrong.. Maybe no languageVersion in DB?";
          _response.status = Status.Failed;
        }else{
          _response.status = Status.Success;
        }
        return _response;
   } 
   public TestPlatformResponse newLanguageVersion(LanguageVersion languageVersion){
        if(_impl.newLanguageVersion(languageVersion)){
          _response.data = true;
          _response.status = Status.Success;
        }else{
          _response.status = Status.Failed;
          _response.error = "LanguageVersion already exists";
        }
        return _response;
   }
   public TestPlatformResponse deleteLanguageVersion(int languageVersionID){
        //TODO restrict who can delete language.
        TestPlatformResponse singleLanguageResponse = getSingleLanguageVersion(languageVersionID);
        _response = singleLanguageResponse;
        LanguageVersion languageVersion = (LanguageVersion) singleLanguageResponse.data;
        if(languageVersion != null){
           if(_impl.deleteLanguageVersion(languageVersion)){
            _response.status = Status.Success;
            _response.data = true;
			_response.error = null;
           }else{
            _response.status = Status.Failed;
            _response.error = "unknown error occured deleting id "+languageVersionID;
           }
        }
        return _response;
   }
    public TestPlatformResponse getSingleLanguageVersion(int languageVersionID){
        _response.data = _impl.getSingleLanguageVersion(languageVersionID);
        if(_response.data == null){
          _response.status = Status.Failed;
          _response.error = "No match for languageVersionID: " + languageVersionID;
        }else{
          _response.status = Status.Success;
        }
        return _response;
   }
}