namespace helper;
using response;
using context;
using impl;
using models;
using request;
public class ResultHelper{

    public TestPlatformResponse _response { get; set; }
    public DBimpl _impl { get; set; }
    public ResultHelper(TestPlatformResponse response, TestPlatformContext context){
        _response = response;
        _impl = new DBimpl(context);
    }

    public TestPlatformResponse getResults(){
        _response.data = _impl.getAllResults();
        if(_response.data == null){
          _response.error = "Something went wrong.. Maybe no Results in DB?";
          _response.status = Status.Failed;
        }else{
          _response.status = Status.Success;
        }
        return _response;
   } 
   public TestPlatformResponse deleteResult(int resultID){
        //TODO restrict who can delete language.
        TestPlatformResponse singleResultResponse = getSingleResult(resultID);
        _response = singleResultResponse;
        Result result = (Result) singleResultResponse.data;
        if(result != null){
           if(_impl.deleteResult(result)){
            _response.status = Status.Success;
            _response.data = true;
			_response.error = null;
           }else{
            _response.status = Status.Failed;
            _response.error = "unknown error occured deleting id "+resultID;
           }
        }
        return _response;
   }
    public TestPlatformResponse getSingleResult(int resultID){
        _response.data = _impl.getSingleResult(resultID);
        if(_response.data == null){
          _response.status = Status.Failed;
          _response.error = "No match for resultID: " + resultID;
        }else{
          _response.status = Status.Success;
        }
        return _response;
   }
}