namespace helper;
using request;
using models;
using response;
using context;
using impl;
public class TestHelper{

    public TestPlatformResponse _response { get; set; }
    public DBimpl _impl { get; set; }
    public TestHelper(TestPlatformResponse response, TestPlatformContext context){
        _response = response;
        _impl = new DBimpl(context);
    }
   public TestPlatformResponse getAllTests(){
        //TODO validate user permissions
        if(false){
            _response.error = "not valid user for action.";
            _response.status = Status.Failed;
            return _response;
        }
        _response.data = _impl.getAllTest();
        if(_response.data == null){
            _response.error = "error: maybe list empty?";
            _response.status = Status.Failed;
        }else{
            _response.status = Status.Success;
        }
        return _response;
   } 
   public TestPlatformResponse getSingleTest(int testID){
        //TODO validate user permissions
        if(false){
            _response.error = "not valid user for action.";
            _response.status = Status.Failed;
            return _response;
        }
        _response.data = _impl.getSingeTest(testID);
        if(_response.data == null){
            _response.error = "did not find test with id "+testID;
            _response.status = Status.Failed;
        }else{
            _response.status = Status.Success;
        }
        return _response;
   } 
   public TestPlatformResponse deleteTest(int testID){
        //TODO validate user permissions
        if(false){
            _response.error = "not valid user for action.";
            _response.status = Status.Failed;
            return _response;
        }
        try{
            Test test = _impl.getSingeTest(testID);
            _impl.deleteTest(test);
        }catch(Exception e){
            _response.error = "test not found for id: "+testID;
            _response.status = Status.Failed;
        }
        return _response;
   } 
   public TestPlatformResponse newTest(TestRequest testRequest){
        //TODO validate user
        if(false){
            _response.error = "not valid user.";
            _response.status = Status.Failed;
            return _response;
        }
        try{
            Test test = testRequest.convertToModelNew(_impl);
            _response.data = _impl.newTest(test);
            _response.status = Status.Success;
        }catch(Exception){
            _response.error = "test convert failure..";
            _response.status = Status.Failed;
        }
        return _response;
   } 
}