namespace helper;
using response;
using context;
using impl;
using models;
using request;
public class UnitTestHelper{

    public TestPlatformResponse _response { get; set; }
    public DBimpl _impl { get; set; }
    public UnitTestHelper(TestPlatformResponse response, TestPlatformContext context){
        _response = response;
        _impl = new DBimpl(context);
    }

    public TestPlatformResponse getAllUnitTests(){
        _response.data = _impl.getAllUnitTests();
        if(_response.data == null){
          _response.error = "Something went wrong.. Maybe no unitTests in DB?";
          _response.status = Status.Failed;
        }else{
          _response.status = Status.Success;
        }
        return _response;
   } 
   public TestPlatformResponse newUnitTest(AssignmentUnitTest unitTest){
        if(_impl.newUnitTest(unitTest)){
          _response.data = true;
          _response.status = Status.Success;
        }else{
          _response.status = Status.Failed;
          _response.error = "UnitTest already exists";
        }
        return _response;
   }
   public TestPlatformResponse deleteUnitTest(int unitTestID){
        //TODO restrict who can delete unittest.
        TestPlatformResponse singleUnitTest = getSingleUnitTest(unitTestID);
        _response = singleUnitTest;
        AssignmentUnitTest unitTest = (AssignmentUnitTest) singleUnitTest.data;
        if(unitTest != null){
           if(_impl.deleteUnitTest(unitTest)){
            _response.status = Status.Success;
            _response.data = true;
			_response.error = null;
           }else{
            _response.status = Status.Failed;
            _response.error = "unknown error occured deleting id "+unitTestID;
           }
        }
        return _response;
   }
    public TestPlatformResponse getSingleUnitTest(int unitTestID){
        _response.data = _impl.getSingleUnitTest(unitTestID);
        if(_response.data == null){
          _response.status = Status.Failed;
          _response.error = "No match for unitTestID: " + unitTestID;
        }else{
          _response.status = Status.Success;
        }
        return _response;
   }
}