namespace helper;
using response;
using request;
using context;
using impl;
using models;
public class UserAssignmentHelper{

    public TestPlatformResponse _response { get; set; }
    public DBimpl _impl { get; set; }
    public UserAssignmentHelper(TestPlatformResponse response, TestPlatformContext context){
        _response = response;
        _impl = new DBimpl(context);
    }

    public TestPlatformResponse getAllUserAssignments(){
        _response.data = _impl.getAllUserAssignments();
        if(_response.data == null){
          _response.error = "Something went wrong.. Maybe no user tests in DB?";
          _response.status = Status.Failed;
        }else{
          _response.status = Status.Success;
        }
        return _response;
   } 
   public TestPlatformResponse newUserAssignment(UserAssignment userAssignment){
          _response.data = _impl.newUserAssignment(userAssignment);
        if(_response != null){
          _response.status = Status.Success;
        }else{
          _response.status = Status.Failed;
          _response.error = "User Assignment already exists";
        }
        return _response;
   }
   public TestPlatformResponse updateUserAssignment(int id, UserAssignment userAssignment){
        if(_impl.updateUserAssignment(id, userAssignment)){
          _response.data = true;
          _response.status = Status.Success;
        }else{
          _response.status = Status.Failed;
          _response.error = "the id doesnt match for update";
        }
        return _response;
   }
   public TestPlatformResponse deleteUserAssignment(int userAssignmentID){
        //TODO restrict who can delete an assignment.
        TestPlatformResponse singleUserAssignmentResponse = getSingleUserAssignment(userAssignmentID);
        _response = singleUserAssignmentResponse;
        UserAssignment userAssignment = (UserAssignment) singleUserAssignmentResponse.data;
        if(userAssignment != null){
           if(_impl.deleteUserAssignment(userAssignment)){
            _response.status = Status.Success;
            _response.data = true;
			_response.error = "";
           }else{
            _response.status = Status.Failed;
            _response.error = "unknown error occured deleting id "+userAssignmentID;
           }
        }
        return _response;
   }
    public TestPlatformResponse getSingleUserAssignment(int userAssignmentID){
        _response.data = _impl.getSingleUserAssignment(userAssignmentID);
        if(_response.data == null){
          _response.status = Status.Failed;
          _response.error = "No match for userAssignmentID: " + userAssignmentID;
        }else{
          _response.status = Status.Success;
        }
        return _response;
   }
}