﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

#nullable disable

namespace api.Migrations
{
    /// <inheritdoc />
    public partial class InitialCreate : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "tbl_OrphanTest",
                columns: table => new
                {
                    id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    user = table.Column<string>(type: "text", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_tbl_OrphanTest", x => x.id);
                });

            migrationBuilder.CreateTable(
                name: "tbl_Result",
                columns: table => new
                {
                    ID = table.Column<long>(type: "bigint", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    DateExec = table.Column<DateTime>(type: "timestamp with time zone", nullable: false),
                    complete = table.Column<int>(type: "integer", nullable: false),
                    runtime = table.Column<long>(type: "bigint", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_tbl_Result", x => x.ID);
                });

            migrationBuilder.CreateTable(
                name: "tbl_Assignment",
                columns: table => new
                {
                    id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    name = table.Column<string>(type: "text", nullable: false),
                    difficulty = table.Column<int>(type: "integer", nullable: false),
                    submissionid = table.Column<int>(type: "integer", nullable: false),
                    released = table.Column<DateTime>(type: "timestamp with time zone", nullable: false),
                    created = table.Column<DateTime>(type: "timestamp with time zone", nullable: false),
                    OrphanTestid = table.Column<int>(type: "integer", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_tbl_Assignment", x => x.id);
                    table.ForeignKey(
                        name: "FK_tbl_Assignment_tbl_OrphanTest_OrphanTestid",
                        column: x => x.OrphanTestid,
                        principalTable: "tbl_OrphanTest",
                        principalColumn: "id");
                });

            migrationBuilder.CreateTable(
                name: "tbl_Attempt",
                columns: table => new
                {
                    id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    date = table.Column<DateTime>(type: "timestamp with time zone", nullable: false),
                    resultID = table.Column<long>(type: "bigint", nullable: false),
                    code = table.Column<string>(type: "text", nullable: false),
                    Assignmentid = table.Column<int>(type: "integer", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_tbl_Attempt", x => x.id);
                    table.ForeignKey(
                        name: "FK_tbl_Attempt_tbl_Assignment_Assignmentid",
                        column: x => x.Assignmentid,
                        principalTable: "tbl_Assignment",
                        principalColumn: "id");
                    table.ForeignKey(
                        name: "FK_tbl_Attempt_tbl_Result_resultID",
                        column: x => x.resultID,
                        principalTable: "tbl_Result",
                        principalColumn: "ID",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "tbl_Language",
                columns: table => new
                {
                    id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    name = table.Column<string>(type: "text", nullable: false),
                    Assignmentid = table.Column<int>(type: "integer", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_tbl_Language", x => x.id);
                    table.ForeignKey(
                        name: "FK_tbl_Language_tbl_Assignment_Assignmentid",
                        column: x => x.Assignmentid,
                        principalTable: "tbl_Assignment",
                        principalColumn: "id");
                });

            migrationBuilder.CreateTable(
                name: "tbl_UnitTest",
                columns: table => new
                {
                    id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    assignmentid = table.Column<int>(type: "integer", nullable: false),
                    unitTest = table.Column<string>(type: "text", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_tbl_UnitTest", x => x.id);
                    table.ForeignKey(
                        name: "FK_tbl_UnitTest_tbl_Assignment_assignmentid",
                        column: x => x.assignmentid,
                        principalTable: "tbl_Assignment",
                        principalColumn: "id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "tbl_LanguageVersion",
                columns: table => new
                {
                    id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    languageid = table.Column<int>(type: "integer", nullable: false),
                    versionName = table.Column<string>(type: "text", nullable: false),
                    versionCode = table.Column<string>(type: "text", nullable: false),
                    codeTemplate = table.Column<string>(type: "text", nullable: false),
                    UnitTestid = table.Column<int>(type: "integer", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_tbl_LanguageVersion", x => x.id);
                    table.ForeignKey(
                        name: "FK_tbl_LanguageVersion_tbl_Language_languageid",
                        column: x => x.languageid,
                        principalTable: "tbl_Language",
                        principalColumn: "id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_tbl_LanguageVersion_tbl_UnitTest_UnitTestid",
                        column: x => x.UnitTestid,
                        principalTable: "tbl_UnitTest",
                        principalColumn: "id");
                });

            migrationBuilder.CreateIndex(
                name: "IX_tbl_Assignment_OrphanTestid",
                table: "tbl_Assignment",
                column: "OrphanTestid");

            migrationBuilder.CreateIndex(
                name: "IX_tbl_Assignment_submissionid",
                table: "tbl_Assignment",
                column: "submissionid");

            migrationBuilder.CreateIndex(
                name: "IX_tbl_Attempt_Assignmentid",
                table: "tbl_Attempt",
                column: "Assignmentid");

            migrationBuilder.CreateIndex(
                name: "IX_tbl_Attempt_resultID",
                table: "tbl_Attempt",
                column: "resultID");

            migrationBuilder.CreateIndex(
                name: "IX_tbl_Language_Assignmentid",
                table: "tbl_Language",
                column: "Assignmentid");

            migrationBuilder.CreateIndex(
                name: "IX_tbl_LanguageVersion_languageid",
                table: "tbl_LanguageVersion",
                column: "languageid");

            migrationBuilder.CreateIndex(
                name: "IX_tbl_LanguageVersion_UnitTestid",
                table: "tbl_LanguageVersion",
                column: "UnitTestid");

            migrationBuilder.CreateIndex(
                name: "IX_tbl_UnitTest_assignmentid",
                table: "tbl_UnitTest",
                column: "assignmentid");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_Assignment_tbl_Attempt_submissionid",
                table: "tbl_Assignment",
                column: "submissionid",
                principalTable: "tbl_Attempt",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_tbl_Assignment_tbl_Attempt_submissionid",
                table: "tbl_Assignment");

            migrationBuilder.DropTable(
                name: "tbl_LanguageVersion");

            migrationBuilder.DropTable(
                name: "tbl_Language");

            migrationBuilder.DropTable(
                name: "tbl_UnitTest");

            migrationBuilder.DropTable(
                name: "tbl_Attempt");

            migrationBuilder.DropTable(
                name: "tbl_Assignment");

            migrationBuilder.DropTable(
                name: "tbl_Result");

            migrationBuilder.DropTable(
                name: "tbl_OrphanTest");
        }
    }
}
