﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

#nullable disable

namespace api.Migrations
{
    /// <inheritdoc />
    public partial class RemodelAssignment : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_tbl_Assignment_tbl_Attempt_submissionid",
                table: "tbl_Assignment");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_Assignment_tbl_OrphanTest_OrphanTestid",
                table: "tbl_Assignment");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_Attempt_tbl_Assignment_Assignmentid",
                table: "tbl_Attempt");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_Attempt_tbl_Result_resultID",
                table: "tbl_Attempt");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_Language_tbl_Assignment_Assignmentid",
                table: "tbl_Language");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_LanguageVersion_tbl_Language_languageid",
                table: "tbl_LanguageVersion");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_LanguageVersion_tbl_UnitTest_UnitTestid",
                table: "tbl_LanguageVersion");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_UnitTest_tbl_Assignment_assignmentid",
                table: "tbl_UnitTest");

            migrationBuilder.DropPrimaryKey(
                name: "PK_tbl_Result",
                table: "tbl_Result");

            migrationBuilder.DropPrimaryKey(
                name: "PK_tbl_Language",
                table: "tbl_Language");

            migrationBuilder.DropPrimaryKey(
                name: "PK_tbl_Attempt",
                table: "tbl_Attempt");

            migrationBuilder.DropPrimaryKey(
                name: "PK_tbl_Assignment",
                table: "tbl_Assignment");

            migrationBuilder.DropIndex(
                name: "IX_tbl_Assignment_submissionid",
                table: "tbl_Assignment");

            migrationBuilder.DropPrimaryKey(
                name: "PK_tbl_UnitTest",
                table: "tbl_UnitTest");

            migrationBuilder.DropPrimaryKey(
                name: "PK_tbl_OrphanTest",
                table: "tbl_OrphanTest");

            migrationBuilder.DropPrimaryKey(
                name: "PK_tbl_LanguageVersion",
                table: "tbl_LanguageVersion");

            migrationBuilder.DropColumn(
                name: "created",
                table: "tbl_Assignment");

            migrationBuilder.DropColumn(
                name: "submissionid",
                table: "tbl_Assignment");

            migrationBuilder.RenameTable(
                name: "tbl_Result",
                newName: "tbl_result");

            migrationBuilder.RenameTable(
                name: "tbl_Language",
                newName: "tbl_language");

            migrationBuilder.RenameTable(
                name: "tbl_Attempt",
                newName: "tbl_attempt");

            migrationBuilder.RenameTable(
                name: "tbl_Assignment",
                newName: "tbl_assignment");

            migrationBuilder.RenameTable(
                name: "tbl_UnitTest",
                newName: "tbl_unit_test");

            migrationBuilder.RenameTable(
                name: "tbl_OrphanTest",
                newName: "tbl_orphan_test");

            migrationBuilder.RenameTable(
                name: "tbl_LanguageVersion",
                newName: "tbl_language_version");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_Language_Assignmentid",
                table: "tbl_language",
                newName: "IX_tbl_language_Assignmentid");

            migrationBuilder.RenameColumn(
                name: "Assignmentid",
                table: "tbl_attempt",
                newName: "UserAssignmentid");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_Attempt_resultID",
                table: "tbl_attempt",
                newName: "IX_tbl_attempt_resultID");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_Attempt_Assignmentid",
                table: "tbl_attempt",
                newName: "IX_tbl_attempt_UserAssignmentid");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_Assignment_OrphanTestid",
                table: "tbl_assignment",
                newName: "IX_tbl_assignment_OrphanTestid");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_UnitTest_assignmentid",
                table: "tbl_unit_test",
                newName: "IX_tbl_unit_test_assignmentid");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_LanguageVersion_UnitTestid",
                table: "tbl_language_version",
                newName: "IX_tbl_language_version_UnitTestid");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_LanguageVersion_languageid",
                table: "tbl_language_version",
                newName: "IX_tbl_language_version_languageid");

            migrationBuilder.AddPrimaryKey(
                name: "PK_tbl_result",
                table: "tbl_result",
                column: "ID");

            migrationBuilder.AddPrimaryKey(
                name: "PK_tbl_language",
                table: "tbl_language",
                column: "id");

            migrationBuilder.AddPrimaryKey(
                name: "PK_tbl_attempt",
                table: "tbl_attempt",
                column: "id");

            migrationBuilder.AddPrimaryKey(
                name: "PK_tbl_assignment",
                table: "tbl_assignment",
                column: "id");

            migrationBuilder.AddPrimaryKey(
                name: "PK_tbl_unit_test",
                table: "tbl_unit_test",
                column: "id");

            migrationBuilder.AddPrimaryKey(
                name: "PK_tbl_orphan_test",
                table: "tbl_orphan_test",
                column: "id");

            migrationBuilder.AddPrimaryKey(
                name: "PK_tbl_language_version",
                table: "tbl_language_version",
                column: "id");

            migrationBuilder.CreateTable(
                name: "tbl_user_assignment",
                columns: table => new
                {
                    id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    submissionid = table.Column<int>(type: "integer", nullable: false),
                    created = table.Column<DateTime>(type: "timestamp with time zone", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_tbl_user_assignment", x => x.id);
                    table.ForeignKey(
                        name: "FK_tbl_user_assignment_tbl_attempt_submissionid",
                        column: x => x.submissionid,
                        principalTable: "tbl_attempt",
                        principalColumn: "id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_tbl_user_assignment_submissionid",
                table: "tbl_user_assignment",
                column: "submissionid");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_assignment_tbl_orphan_test_OrphanTestid",
                table: "tbl_assignment",
                column: "OrphanTestid",
                principalTable: "tbl_orphan_test",
                principalColumn: "id");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_attempt_tbl_result_resultID",
                table: "tbl_attempt",
                column: "resultID",
                principalTable: "tbl_result",
                principalColumn: "ID",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_attempt_tbl_user_assignment_UserAssignmentid",
                table: "tbl_attempt",
                column: "UserAssignmentid",
                principalTable: "tbl_user_assignment",
                principalColumn: "id");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_language_tbl_assignment_Assignmentid",
                table: "tbl_language",
                column: "Assignmentid",
                principalTable: "tbl_assignment",
                principalColumn: "id");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_language_version_tbl_language_languageid",
                table: "tbl_language_version",
                column: "languageid",
                principalTable: "tbl_language",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_language_version_tbl_unit_test_UnitTestid",
                table: "tbl_language_version",
                column: "UnitTestid",
                principalTable: "tbl_unit_test",
                principalColumn: "id");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_unit_test_tbl_assignment_assignmentid",
                table: "tbl_unit_test",
                column: "assignmentid",
                principalTable: "tbl_assignment",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_tbl_assignment_tbl_orphan_test_OrphanTestid",
                table: "tbl_assignment");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_attempt_tbl_result_resultID",
                table: "tbl_attempt");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_attempt_tbl_user_assignment_UserAssignmentid",
                table: "tbl_attempt");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_language_tbl_assignment_Assignmentid",
                table: "tbl_language");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_language_version_tbl_language_languageid",
                table: "tbl_language_version");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_language_version_tbl_unit_test_UnitTestid",
                table: "tbl_language_version");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_unit_test_tbl_assignment_assignmentid",
                table: "tbl_unit_test");

            migrationBuilder.DropTable(
                name: "tbl_user_assignment");

            migrationBuilder.DropPrimaryKey(
                name: "PK_tbl_result",
                table: "tbl_result");

            migrationBuilder.DropPrimaryKey(
                name: "PK_tbl_language",
                table: "tbl_language");

            migrationBuilder.DropPrimaryKey(
                name: "PK_tbl_attempt",
                table: "tbl_attempt");

            migrationBuilder.DropPrimaryKey(
                name: "PK_tbl_assignment",
                table: "tbl_assignment");

            migrationBuilder.DropPrimaryKey(
                name: "PK_tbl_unit_test",
                table: "tbl_unit_test");

            migrationBuilder.DropPrimaryKey(
                name: "PK_tbl_orphan_test",
                table: "tbl_orphan_test");

            migrationBuilder.DropPrimaryKey(
                name: "PK_tbl_language_version",
                table: "tbl_language_version");

            migrationBuilder.RenameTable(
                name: "tbl_result",
                newName: "tbl_Result");

            migrationBuilder.RenameTable(
                name: "tbl_language",
                newName: "tbl_Language");

            migrationBuilder.RenameTable(
                name: "tbl_attempt",
                newName: "tbl_Attempt");

            migrationBuilder.RenameTable(
                name: "tbl_assignment",
                newName: "tbl_Assignment");

            migrationBuilder.RenameTable(
                name: "tbl_unit_test",
                newName: "tbl_UnitTest");

            migrationBuilder.RenameTable(
                name: "tbl_orphan_test",
                newName: "tbl_OrphanTest");

            migrationBuilder.RenameTable(
                name: "tbl_language_version",
                newName: "tbl_LanguageVersion");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_language_Assignmentid",
                table: "tbl_Language",
                newName: "IX_tbl_Language_Assignmentid");

            migrationBuilder.RenameColumn(
                name: "UserAssignmentid",
                table: "tbl_Attempt",
                newName: "Assignmentid");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_attempt_resultID",
                table: "tbl_Attempt",
                newName: "IX_tbl_Attempt_resultID");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_attempt_UserAssignmentid",
                table: "tbl_Attempt",
                newName: "IX_tbl_Attempt_Assignmentid");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_assignment_OrphanTestid",
                table: "tbl_Assignment",
                newName: "IX_tbl_Assignment_OrphanTestid");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_unit_test_assignmentid",
                table: "tbl_UnitTest",
                newName: "IX_tbl_UnitTest_assignmentid");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_language_version_UnitTestid",
                table: "tbl_LanguageVersion",
                newName: "IX_tbl_LanguageVersion_UnitTestid");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_language_version_languageid",
                table: "tbl_LanguageVersion",
                newName: "IX_tbl_LanguageVersion_languageid");

            migrationBuilder.AddColumn<DateTime>(
                name: "created",
                table: "tbl_Assignment",
                type: "timestamp with time zone",
                nullable: false,
                defaultValue: new DateTime(1, 1, 1, 0, 0, 0, 0, DateTimeKind.Unspecified));

            migrationBuilder.AddColumn<int>(
                name: "submissionid",
                table: "tbl_Assignment",
                type: "integer",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddPrimaryKey(
                name: "PK_tbl_Result",
                table: "tbl_Result",
                column: "ID");

            migrationBuilder.AddPrimaryKey(
                name: "PK_tbl_Language",
                table: "tbl_Language",
                column: "id");

            migrationBuilder.AddPrimaryKey(
                name: "PK_tbl_Attempt",
                table: "tbl_Attempt",
                column: "id");

            migrationBuilder.AddPrimaryKey(
                name: "PK_tbl_Assignment",
                table: "tbl_Assignment",
                column: "id");

            migrationBuilder.AddPrimaryKey(
                name: "PK_tbl_UnitTest",
                table: "tbl_UnitTest",
                column: "id");

            migrationBuilder.AddPrimaryKey(
                name: "PK_tbl_OrphanTest",
                table: "tbl_OrphanTest",
                column: "id");

            migrationBuilder.AddPrimaryKey(
                name: "PK_tbl_LanguageVersion",
                table: "tbl_LanguageVersion",
                column: "id");

            migrationBuilder.CreateIndex(
                name: "IX_tbl_Assignment_submissionid",
                table: "tbl_Assignment",
                column: "submissionid");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_Assignment_tbl_Attempt_submissionid",
                table: "tbl_Assignment",
                column: "submissionid",
                principalTable: "tbl_Attempt",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_Assignment_tbl_OrphanTest_OrphanTestid",
                table: "tbl_Assignment",
                column: "OrphanTestid",
                principalTable: "tbl_OrphanTest",
                principalColumn: "id");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_Attempt_tbl_Assignment_Assignmentid",
                table: "tbl_Attempt",
                column: "Assignmentid",
                principalTable: "tbl_Assignment",
                principalColumn: "id");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_Attempt_tbl_Result_resultID",
                table: "tbl_Attempt",
                column: "resultID",
                principalTable: "tbl_Result",
                principalColumn: "ID",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_Language_tbl_Assignment_Assignmentid",
                table: "tbl_Language",
                column: "Assignmentid",
                principalTable: "tbl_Assignment",
                principalColumn: "id");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_LanguageVersion_tbl_Language_languageid",
                table: "tbl_LanguageVersion",
                column: "languageid",
                principalTable: "tbl_Language",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_LanguageVersion_tbl_UnitTest_UnitTestid",
                table: "tbl_LanguageVersion",
                column: "UnitTestid",
                principalTable: "tbl_UnitTest",
                principalColumn: "id");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_UnitTest_tbl_Assignment_assignmentid",
                table: "tbl_UnitTest",
                column: "assignmentid",
                principalTable: "tbl_Assignment",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
