﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace api.Migrations
{
    /// <inheritdoc />
    public partial class TestInterfaceChanges : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_tbl_assignment_tbl_orphan_test_OrphanTestid",
                table: "tbl_assignment");

            migrationBuilder.DropIndex(
                name: "IX_tbl_assignment_OrphanTestid",
                table: "tbl_assignment");

            migrationBuilder.DropPrimaryKey(
                name: "PK_tbl_orphan_test",
                table: "tbl_orphan_test");

            migrationBuilder.DropColumn(
                name: "OrphanTestid",
                table: "tbl_assignment");

            migrationBuilder.RenameTable(
                name: "tbl_orphan_test",
                newName: "Test");

            migrationBuilder.AddColumn<int>(
                name: "Testid",
                table: "tbl_user_assignment",
                type: "integer",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "user",
                table: "Test",
                type: "text",
                nullable: true,
                oldClrType: typeof(string),
                oldType: "text");

            migrationBuilder.AlterColumn<bool>(
                name: "isDeleted",
                table: "Test",
                type: "boolean",
                nullable: true,
                oldClrType: typeof(bool),
                oldType: "boolean");

            migrationBuilder.AddColumn<string>(
                name: "Discriminator",
                table: "Test",
                type: "text",
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddColumn<int>(
                name: "testid",
                table: "Test",
                type: "integer",
                nullable: true);

            migrationBuilder.AddPrimaryKey(
                name: "PK_Test",
                table: "Test",
                column: "id");

            migrationBuilder.CreateIndex(
                name: "IX_tbl_user_assignment_Testid",
                table: "tbl_user_assignment",
                column: "Testid");

            migrationBuilder.CreateIndex(
                name: "IX_Test_testid",
                table: "Test",
                column: "testid");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_user_assignment_Test_Testid",
                table: "tbl_user_assignment",
                column: "Testid",
                principalTable: "Test",
                principalColumn: "id");

            migrationBuilder.AddForeignKey(
                name: "FK_Test_Test_testid",
                table: "Test",
                column: "testid",
                principalTable: "Test",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_tbl_user_assignment_Test_Testid",
                table: "tbl_user_assignment");

            migrationBuilder.DropForeignKey(
                name: "FK_Test_Test_testid",
                table: "Test");

            migrationBuilder.DropIndex(
                name: "IX_tbl_user_assignment_Testid",
                table: "tbl_user_assignment");

            migrationBuilder.DropPrimaryKey(
                name: "PK_Test",
                table: "Test");

            migrationBuilder.DropIndex(
                name: "IX_Test_testid",
                table: "Test");

            migrationBuilder.DropColumn(
                name: "Testid",
                table: "tbl_user_assignment");

            migrationBuilder.DropColumn(
                name: "Discriminator",
                table: "Test");

            migrationBuilder.DropColumn(
                name: "testid",
                table: "Test");

            migrationBuilder.RenameTable(
                name: "Test",
                newName: "tbl_orphan_test");

            migrationBuilder.AddColumn<int>(
                name: "OrphanTestid",
                table: "tbl_assignment",
                type: "integer",
                nullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "user",
                table: "tbl_orphan_test",
                type: "text",
                nullable: false,
                defaultValue: "",
                oldClrType: typeof(string),
                oldType: "text",
                oldNullable: true);

            migrationBuilder.AlterColumn<bool>(
                name: "isDeleted",
                table: "tbl_orphan_test",
                type: "boolean",
                nullable: false,
                defaultValue: false,
                oldClrType: typeof(bool),
                oldType: "boolean",
                oldNullable: true);

            migrationBuilder.AddPrimaryKey(
                name: "PK_tbl_orphan_test",
                table: "tbl_orphan_test",
                column: "id");

            migrationBuilder.CreateIndex(
                name: "IX_tbl_assignment_OrphanTestid",
                table: "tbl_assignment",
                column: "OrphanTestid");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_assignment_tbl_orphan_test_OrphanTestid",
                table: "tbl_assignment",
                column: "OrphanTestid",
                principalTable: "tbl_orphan_test",
                principalColumn: "id");
        }
    }
}
