﻿using Microsoft.EntityFrameworkCore.Migrations;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

#nullable disable

namespace api.Migrations
{
    /// <inheritdoc />
    public partial class fixingInheritanceInTest : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_tbl_test_tbl_test_testid",
                table: "tbl_test");

            migrationBuilder.DropIndex(
                name: "IX_tbl_test_testid",
                table: "tbl_test");

            migrationBuilder.DropColumn(
                name: "Discriminator",
                table: "tbl_test");

            migrationBuilder.DropColumn(
                name: "testid",
                table: "tbl_test");

            migrationBuilder.DropColumn(
                name: "user",
                table: "tbl_test");

            migrationBuilder.AlterColumn<bool>(
                name: "isDeleted",
                table: "tbl_test",
                type: "boolean",
                nullable: false,
                defaultValue: false,
                oldClrType: typeof(bool),
                oldType: "boolean",
                oldNullable: true);

            migrationBuilder.CreateTable(
                name: "tbl_orphan_test",
                columns: table => new
                {
                    id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    testid = table.Column<int>(type: "integer", nullable: false),
                    user = table.Column<string>(type: "text", nullable: false),
                    isDeleted = table.Column<bool>(type: "boolean", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_tbl_orphan_test", x => x.id);
                    table.ForeignKey(
                        name: "FK_tbl_orphan_test_tbl_test_testid",
                        column: x => x.testid,
                        principalTable: "tbl_test",
                        principalColumn: "id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_tbl_orphan_test_testid",
                table: "tbl_orphan_test",
                column: "testid");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "tbl_orphan_test");

            migrationBuilder.AlterColumn<bool>(
                name: "isDeleted",
                table: "tbl_test",
                type: "boolean",
                nullable: true,
                oldClrType: typeof(bool),
                oldType: "boolean");

            migrationBuilder.AddColumn<string>(
                name: "Discriminator",
                table: "tbl_test",
                type: "text",
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddColumn<int>(
                name: "testid",
                table: "tbl_test",
                type: "integer",
                nullable: true);

            migrationBuilder.AddColumn<string>(
                name: "user",
                table: "tbl_test",
                type: "text",
                nullable: true);

            migrationBuilder.CreateIndex(
                name: "IX_tbl_test_testid",
                table: "tbl_test",
                column: "testid");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_test_tbl_test_testid",
                table: "tbl_test",
                column: "testid",
                principalTable: "tbl_test",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
