﻿using Microsoft.EntityFrameworkCore.Migrations;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

#nullable disable

namespace api.Migrations
{
    /// <inheritdoc />
    public partial class removedunsusedparameter : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_tbl_language_version_tbl_unit_test_UnitTestid",
                table: "tbl_language_version");

            migrationBuilder.DropTable(
                name: "tbl_unit_test");

            migrationBuilder.RenameColumn(
                name: "UnitTestid",
                table: "tbl_language_version",
                newName: "AssignmentUnitTestid");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_language_version_UnitTestid",
                table: "tbl_language_version",
                newName: "IX_tbl_language_version_AssignmentUnitTestid");

            migrationBuilder.AddColumn<int>(
                name: "testType",
                table: "tbl_test",
                type: "integer",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.CreateTable(
                name: "tbl_assignment_unit_test",
                columns: table => new
                {
                    id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    assignmentid = table.Column<int>(type: "integer", nullable: false),
                    unitTest = table.Column<string>(type: "text", nullable: false),
                    isDeleted = table.Column<bool>(type: "boolean", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_tbl_assignment_unit_test", x => x.id);
                    table.ForeignKey(
                        name: "FK_tbl_assignment_unit_test_tbl_assignment_assignmentid",
                        column: x => x.assignmentid,
                        principalTable: "tbl_assignment",
                        principalColumn: "id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_tbl_assignment_unit_test_assignmentid",
                table: "tbl_assignment_unit_test",
                column: "assignmentid");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_language_version_tbl_assignment_unit_test_AssignmentUni~",
                table: "tbl_language_version",
                column: "AssignmentUnitTestid",
                principalTable: "tbl_assignment_unit_test",
                principalColumn: "id");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_tbl_language_version_tbl_assignment_unit_test_AssignmentUni~",
                table: "tbl_language_version");

            migrationBuilder.DropTable(
                name: "tbl_assignment_unit_test");

            migrationBuilder.DropColumn(
                name: "testType",
                table: "tbl_test");

            migrationBuilder.RenameColumn(
                name: "AssignmentUnitTestid",
                table: "tbl_language_version",
                newName: "UnitTestid");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_language_version_AssignmentUnitTestid",
                table: "tbl_language_version",
                newName: "IX_tbl_language_version_UnitTestid");

            migrationBuilder.CreateTable(
                name: "tbl_unit_test",
                columns: table => new
                {
                    id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    assignmentid = table.Column<int>(type: "integer", nullable: false),
                    isDeleted = table.Column<bool>(type: "boolean", nullable: false),
                    unitTest = table.Column<string>(type: "text", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_tbl_unit_test", x => x.id);
                    table.ForeignKey(
                        name: "FK_tbl_unit_test_tbl_assignment_assignmentid",
                        column: x => x.assignmentid,
                        principalTable: "tbl_assignment",
                        principalColumn: "id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_tbl_unit_test_assignmentid",
                table: "tbl_unit_test",
                column: "assignmentid");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_language_version_tbl_unit_test_UnitTestid",
                table: "tbl_language_version",
                column: "UnitTestid",
                principalTable: "tbl_unit_test",
                principalColumn: "id");
        }
    }
}
