﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace api.Migrations
{
    /// <inheritdoc />
    public partial class movedLanguageAndLanguageversion : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_tbl_language_tbl_assignment_Assignmentid",
                table: "tbl_language");

            migrationBuilder.DropIndex(
                name: "IX_tbl_language_Assignmentid",
                table: "tbl_language");

            migrationBuilder.DropColumn(
                name: "Assignmentid",
                table: "tbl_language");

            migrationBuilder.CreateTable(
                name: "AssignmentLanguageVersion",
                columns: table => new
                {
                    assignmentsid = table.Column<int>(type: "integer", nullable: false),
                    availableLanguagesid = table.Column<int>(type: "integer", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_AssignmentLanguageVersion", x => new { x.assignmentsid, x.availableLanguagesid });
                    table.ForeignKey(
                        name: "FK_AssignmentLanguageVersion_tbl_assignment_assignmentsid",
                        column: x => x.assignmentsid,
                        principalTable: "tbl_assignment",
                        principalColumn: "id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_AssignmentLanguageVersion_tbl_language_version_availableLan~",
                        column: x => x.availableLanguagesid,
                        principalTable: "tbl_language_version",
                        principalColumn: "id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_AssignmentLanguageVersion_availableLanguagesid",
                table: "AssignmentLanguageVersion",
                column: "availableLanguagesid");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "AssignmentLanguageVersion");

            migrationBuilder.AddColumn<int>(
                name: "Assignmentid",
                table: "tbl_language",
                type: "integer",
                nullable: true);

            migrationBuilder.CreateIndex(
                name: "IX_tbl_language_Assignmentid",
                table: "tbl_language",
                column: "Assignmentid");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_language_tbl_assignment_Assignmentid",
                table: "tbl_language",
                column: "Assignmentid",
                principalTable: "tbl_assignment",
                principalColumn: "id");
        }
    }
}
