﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace api.Migrations
{
    /// <inheritdoc />
    public partial class connectedTailOfDB : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_tbl_attempt_tbl_result_resultID",
                table: "tbl_attempt");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_attempt_tbl_user_assignment_userAssignmentid",
                table: "tbl_attempt");

            migrationBuilder.DropIndex(
                name: "IX_tbl_attempt_resultID",
                table: "tbl_attempt");

            migrationBuilder.RenameColumn(
                name: "userAssignmentid",
                table: "tbl_attempt",
                newName: "userAssignmentID");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_attempt_userAssignmentid",
                table: "tbl_attempt",
                newName: "IX_tbl_attempt_userAssignmentID");

            migrationBuilder.AddColumn<int>(
                name: "attemptID",
                table: "tbl_result",
                type: "integer",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AlterColumn<int>(
                name: "resultID",
                table: "tbl_attempt",
                type: "integer",
                nullable: false,
                oldClrType: typeof(long),
                oldType: "bigint");

            migrationBuilder.CreateIndex(
                name: "IX_tbl_result_attemptID",
                table: "tbl_result",
                column: "attemptID",
                unique: true);

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_attempt_tbl_user_assignment_userAssignmentID",
                table: "tbl_attempt",
                column: "userAssignmentID",
                principalTable: "tbl_user_assignment",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_result_tbl_attempt_attemptID",
                table: "tbl_result",
                column: "attemptID",
                principalTable: "tbl_attempt",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_tbl_attempt_tbl_user_assignment_userAssignmentID",
                table: "tbl_attempt");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_result_tbl_attempt_attemptID",
                table: "tbl_result");

            migrationBuilder.DropIndex(
                name: "IX_tbl_result_attemptID",
                table: "tbl_result");

            migrationBuilder.DropColumn(
                name: "attemptID",
                table: "tbl_result");

            migrationBuilder.RenameColumn(
                name: "userAssignmentID",
                table: "tbl_attempt",
                newName: "userAssignmentid");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_attempt_userAssignmentID",
                table: "tbl_attempt",
                newName: "IX_tbl_attempt_userAssignmentid");

            migrationBuilder.AlterColumn<long>(
                name: "resultID",
                table: "tbl_attempt",
                type: "bigint",
                nullable: false,
                oldClrType: typeof(int),
                oldType: "integer");

            migrationBuilder.CreateIndex(
                name: "IX_tbl_attempt_resultID",
                table: "tbl_attempt",
                column: "resultID");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_attempt_tbl_result_resultID",
                table: "tbl_attempt",
                column: "resultID",
                principalTable: "tbl_result",
                principalColumn: "ID",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_attempt_tbl_user_assignment_userAssignmentid",
                table: "tbl_attempt",
                column: "userAssignmentid",
                principalTable: "tbl_user_assignment",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
