﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace api.Migrations
{
    /// <inheritdoc />
    public partial class refactoredDB : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_tbl_assignment_unit_test_tbl_assignment_assignmentid",
                table: "tbl_assignment_unit_test");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_assignment_unit_test_tbl_language_version_languageVersi~",
                table: "tbl_assignment_unit_test");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_language_version_tbl_language_languageid",
                table: "tbl_language_version");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_orphan_test_tbl_test_testid",
                table: "tbl_orphan_test");

            migrationBuilder.DropTable(
                name: "AssignmentLanguageVersion");

            migrationBuilder.DropColumn(
                name: "codeTemplate",
                table: "tbl_language_version");

            migrationBuilder.RenameColumn(
                name: "testid",
                table: "tbl_orphan_test",
                newName: "testID");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_orphan_test_testid",
                table: "tbl_orphan_test",
                newName: "IX_tbl_orphan_test_testID");

            migrationBuilder.RenameColumn(
                name: "languageid",
                table: "tbl_language_version",
                newName: "languageID");

            migrationBuilder.RenameColumn(
                name: "versionName",
                table: "tbl_language_version",
                newName: "name");

            migrationBuilder.RenameColumn(
                name: "versionCode",
                table: "tbl_language_version",
                newName: "code");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_language_version_languageid",
                table: "tbl_language_version",
                newName: "IX_tbl_language_version_languageID");

            migrationBuilder.RenameColumn(
                name: "assignmentid",
                table: "tbl_assignment_unit_test",
                newName: "assignmentID");

            migrationBuilder.RenameColumn(
                name: "languageVersionsid",
                table: "tbl_assignment_unit_test",
                newName: "languageID");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_assignment_unit_test_assignmentid",
                table: "tbl_assignment_unit_test",
                newName: "IX_tbl_assignment_unit_test_assignmentID");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_assignment_unit_test_languageVersionsid",
                table: "tbl_assignment_unit_test",
                newName: "IX_tbl_assignment_unit_test_languageID");

            migrationBuilder.AddColumn<int>(
                name: "languageID",
                table: "tbl_user_assignment",
                type: "integer",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<string>(
                name: "codeTemplate",
                table: "tbl_language",
                type: "text",
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddColumn<string>(
                name: "secretUnitTest",
                table: "tbl_assignment_unit_test",
                type: "text",
                nullable: false,
                defaultValue: "");

            migrationBuilder.CreateTable(
                name: "AssignmentLanguage",
                columns: table => new
                {
                    assignmentid = table.Column<int>(type: "integer", nullable: false),
                    languagesid = table.Column<int>(type: "integer", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_AssignmentLanguage", x => new { x.assignmentid, x.languagesid });
                    table.ForeignKey(
                        name: "FK_AssignmentLanguage_tbl_assignment_assignmentid",
                        column: x => x.assignmentid,
                        principalTable: "tbl_assignment",
                        principalColumn: "id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_AssignmentLanguage_tbl_language_languagesid",
                        column: x => x.languagesid,
                        principalTable: "tbl_language",
                        principalColumn: "id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_tbl_user_assignment_languageID",
                table: "tbl_user_assignment",
                column: "languageID");

            migrationBuilder.CreateIndex(
                name: "IX_AssignmentLanguage_languagesid",
                table: "AssignmentLanguage",
                column: "languagesid");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_assignment_unit_test_tbl_assignment_assignmentID",
                table: "tbl_assignment_unit_test",
                column: "assignmentID",
                principalTable: "tbl_assignment",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_assignment_unit_test_tbl_language_languageID",
                table: "tbl_assignment_unit_test",
                column: "languageID",
                principalTable: "tbl_language",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_language_version_tbl_language_languageID",
                table: "tbl_language_version",
                column: "languageID",
                principalTable: "tbl_language",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_orphan_test_tbl_test_testID",
                table: "tbl_orphan_test",
                column: "testID",
                principalTable: "tbl_test",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_user_assignment_tbl_language_languageID",
                table: "tbl_user_assignment",
                column: "languageID",
                principalTable: "tbl_language",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_tbl_assignment_unit_test_tbl_assignment_assignmentID",
                table: "tbl_assignment_unit_test");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_assignment_unit_test_tbl_language_languageID",
                table: "tbl_assignment_unit_test");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_language_version_tbl_language_languageID",
                table: "tbl_language_version");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_orphan_test_tbl_test_testID",
                table: "tbl_orphan_test");

            migrationBuilder.DropForeignKey(
                name: "FK_tbl_user_assignment_tbl_language_languageID",
                table: "tbl_user_assignment");

            migrationBuilder.DropTable(
                name: "AssignmentLanguage");

            migrationBuilder.DropIndex(
                name: "IX_tbl_user_assignment_languageID",
                table: "tbl_user_assignment");

            migrationBuilder.DropColumn(
                name: "languageID",
                table: "tbl_user_assignment");

            migrationBuilder.DropColumn(
                name: "codeTemplate",
                table: "tbl_language");

            migrationBuilder.DropColumn(
                name: "secretUnitTest",
                table: "tbl_assignment_unit_test");

            migrationBuilder.RenameColumn(
                name: "testID",
                table: "tbl_orphan_test",
                newName: "testid");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_orphan_test_testID",
                table: "tbl_orphan_test",
                newName: "IX_tbl_orphan_test_testid");

            migrationBuilder.RenameColumn(
                name: "languageID",
                table: "tbl_language_version",
                newName: "languageid");

            migrationBuilder.RenameColumn(
                name: "name",
                table: "tbl_language_version",
                newName: "versionName");

            migrationBuilder.RenameColumn(
                name: "code",
                table: "tbl_language_version",
                newName: "versionCode");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_language_version_languageID",
                table: "tbl_language_version",
                newName: "IX_tbl_language_version_languageid");

            migrationBuilder.RenameColumn(
                name: "assignmentID",
                table: "tbl_assignment_unit_test",
                newName: "assignmentid");

            migrationBuilder.RenameColumn(
                name: "languageID",
                table: "tbl_assignment_unit_test",
                newName: "languageVersionsid");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_assignment_unit_test_assignmentID",
                table: "tbl_assignment_unit_test",
                newName: "IX_tbl_assignment_unit_test_assignmentid");

            migrationBuilder.RenameIndex(
                name: "IX_tbl_assignment_unit_test_languageID",
                table: "tbl_assignment_unit_test",
                newName: "IX_tbl_assignment_unit_test_languageVersionsid");

            migrationBuilder.AddColumn<string>(
                name: "codeTemplate",
                table: "tbl_language_version",
                type: "text",
                nullable: false,
                defaultValue: "");

            migrationBuilder.CreateTable(
                name: "AssignmentLanguageVersion",
                columns: table => new
                {
                    assignmentsid = table.Column<int>(type: "integer", nullable: false),
                    availableLanguagesid = table.Column<int>(type: "integer", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_AssignmentLanguageVersion", x => new { x.assignmentsid, x.availableLanguagesid });
                    table.ForeignKey(
                        name: "FK_AssignmentLanguageVersion_tbl_assignment_assignmentsid",
                        column: x => x.assignmentsid,
                        principalTable: "tbl_assignment",
                        principalColumn: "id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_AssignmentLanguageVersion_tbl_language_version_availableLan~",
                        column: x => x.availableLanguagesid,
                        principalTable: "tbl_language_version",
                        principalColumn: "id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_AssignmentLanguageVersion_availableLanguagesid",
                table: "AssignmentLanguageVersion",
                column: "availableLanguagesid");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_assignment_unit_test_tbl_assignment_assignmentid",
                table: "tbl_assignment_unit_test",
                column: "assignmentid",
                principalTable: "tbl_assignment",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_assignment_unit_test_tbl_language_version_languageVersi~",
                table: "tbl_assignment_unit_test",
                column: "languageVersionsid",
                principalTable: "tbl_language_version",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_language_version_tbl_language_languageid",
                table: "tbl_language_version",
                column: "languageid",
                principalTable: "tbl_language",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_orphan_test_tbl_test_testid",
                table: "tbl_orphan_test",
                column: "testid",
                principalTable: "tbl_test",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
