﻿using Microsoft.EntityFrameworkCore.Migrations;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

#nullable disable

namespace api.Migrations
{
    /// <inheritdoc />
    public partial class backendRefactorLVandColumns : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_tbl_user_assignment_tbl_language_version_languageVersionID",
                table: "tbl_user_assignment");

            migrationBuilder.DropTable(
                name: "tbl_orphan_test");

            migrationBuilder.DropIndex(
                name: "IX_tbl_user_assignment_languageVersionID",
                table: "tbl_user_assignment");

            migrationBuilder.DropColumn(
                name: "languageVersionID",
                table: "tbl_user_assignment");

            migrationBuilder.RenameColumn(
                name: "testType",
                table: "tbl_test",
                newName: "testTypeID");

            migrationBuilder.AddColumn<string>(
                name: "link",
                table: "tbl_test",
                type: "text",
                nullable: true);

            migrationBuilder.AddColumn<string>(
                name: "owner",
                table: "tbl_test",
                type: "text",
                nullable: true);

            migrationBuilder.AddColumn<string>(
                name: "user",
                table: "tbl_test",
                type: "text",
                nullable: true);

            migrationBuilder.AddColumn<int>(
                name: "languageVersionID",
                table: "tbl_attempt",
                type: "integer",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<string>(
                name: "startCode",
                table: "tbl_assignment_unit_test",
                type: "text",
                nullable: false,
                defaultValue: "");

            migrationBuilder.CreateIndex(
                name: "IX_tbl_attempt_languageVersionID",
                table: "tbl_attempt",
                column: "languageVersionID");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_attempt_tbl_language_version_languageVersionID",
                table: "tbl_attempt",
                column: "languageVersionID",
                principalTable: "tbl_language_version",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_tbl_attempt_tbl_language_version_languageVersionID",
                table: "tbl_attempt");

            migrationBuilder.DropIndex(
                name: "IX_tbl_attempt_languageVersionID",
                table: "tbl_attempt");

            migrationBuilder.DropColumn(
                name: "link",
                table: "tbl_test");

            migrationBuilder.DropColumn(
                name: "owner",
                table: "tbl_test");

            migrationBuilder.DropColumn(
                name: "user",
                table: "tbl_test");

            migrationBuilder.DropColumn(
                name: "languageVersionID",
                table: "tbl_attempt");

            migrationBuilder.DropColumn(
                name: "startCode",
                table: "tbl_assignment_unit_test");

            migrationBuilder.RenameColumn(
                name: "testTypeID",
                table: "tbl_test",
                newName: "testType");

            migrationBuilder.AddColumn<int>(
                name: "languageVersionID",
                table: "tbl_user_assignment",
                type: "integer",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.CreateTable(
                name: "tbl_orphan_test",
                columns: table => new
                {
                    id = table.Column<int>(type: "integer", nullable: false)
                        .Annotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn),
                    testID = table.Column<int>(type: "integer", nullable: false),
                    isDeleted = table.Column<bool>(type: "boolean", nullable: false),
                    user = table.Column<string>(type: "text", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_tbl_orphan_test", x => x.id);
                    table.ForeignKey(
                        name: "FK_tbl_orphan_test_tbl_test_testID",
                        column: x => x.testID,
                        principalTable: "tbl_test",
                        principalColumn: "id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_tbl_user_assignment_languageVersionID",
                table: "tbl_user_assignment",
                column: "languageVersionID");

            migrationBuilder.CreateIndex(
                name: "IX_tbl_orphan_test_testID",
                table: "tbl_orphan_test",
                column: "testID");

            migrationBuilder.AddForeignKey(
                name: "FK_tbl_user_assignment_tbl_language_version_languageVersionID",
                table: "tbl_user_assignment",
                column: "languageVersionID",
                principalTable: "tbl_language_version",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);
        }
    }
}
