import React, { useState } from "react";
import { Route, Routes } from "react-router-dom";
import { useNavigate } from 'react-router-dom';
import TestsView from "./views/TestsView";
import Header from "./components/Header";
import Assignment from "./views/AssignmentView.js";
import AdminView from "./views/AdminView"
import HomeView from "./views/HomeView";
import appcss from "./styles/app.css"
import defaultcss from "./styles/default.css"
import testcss from "./styles/test.css"
import assignmentcss from "./styles/assignment.css"
import assignmentcomponentcss from "./styles/assignment-components.css"
import admincss from "./styles/admin.css"
import tabcss from "./styles/tab.css"


function App() {
	const [user, setUser] = useState({name:'', set:false});
	const navigate = useNavigate();

	function handleUser(value, field){
		const tmp = {...user};
		tmp[`${field}`] = value;
		setUser(tmp);
		if(field="set"){
			navigate("/")
		}
	}

	if(user.set){
		return (
			<div className="app-container">
					<Header handler={setUser}/>
				<div className="page-container">
					<Routes>
						<Route path="/" element={<HomeView name={user.name}/>} />
						<Route path="/test" element={<TestsView name={user.name} />} />
						<Route path="/admin" element={<AdminView />} />
						<Route path="/assignment" element={<Assignment name={user.name} />} />
					</Routes>
				</div>
			</div>
		);
	}else{
		return(
			<div className="app-container">
					<Header />
				<div className="page-container">
						<div>
							THIS IS A DEMO APPLICATION WITH NO USER LOGIN SYSTEM, PLEASE SELECT A USERNAME THE DATABASE CAN UPDATE TESTS TO
							<input value={user.name} onChange={(event) => handleUser(event.target.value,"name")} type="text" />
							<button onClick={(event) => handleUser(!user.set, "set")}>Select</button>
						</div>
				</div>
			</div>
		)
	}
}
// <Route path="/assignment" element={<Assignment test={dummyTest[0]}/>} />

export default App;