import React from 'react'
import { useState, useEffect } from 'react';
import Select from '../Select';
import AdminAssignmentFields from './AdminAssignmentFields';

function AdminAssignment({type}) {
    const newAssignment = { id:999999, description:'', name:'', unitTests:[], languages:[], difficulty:0}
    const [assignment, setAssignment] = useState(type=="new"?newAssignment:undefined);
    const [assignments, setAssignments] = useState([]);

    useEffect( () => {
		console.log(assignment);
    }, [assignment] )

	const handleUpdateAssignment = (e) => {
		if(e.target.value == undefined){
			setAssignment({})
		}
		setAssignment( {...assignments.find( a => a.id == e.target.value)} );
	}

    useEffect(()=> { 
        fetch('http://localhost:5291/api/Assignment')
            .then((res) => res.json())
            .then((data) => {
            	setAssignments(data.data); 
				setAssignment(data.data[0])
			})
			} ,[])
	function renderByType(){
		if(type == "new" && (assignment == undefined || assignment.id != 999999)){
			setAssignment(newAssignment);
		}
		if(type == "update"){
			if(assignment != undefined && assignment.id == 999999){
				setAssignment(assignments[0])
			}
			return (
				<>
					<Select list={assignments} handler={handleUpdateAssignment}/>
					{assignment!=undefined  && <AdminAssignmentFields assignment={assignment} handler={setAssignment} type={type}/>}
				</>
			)
		}else if(type == "new"){
			return(<AdminAssignmentFields assignment={assignment} handler={setAssignment} type={type}/>)
		}
	}
  return (
    <div className='admin-right-container'> 
		{renderByType()}
    </div>
  )
}

export default AdminAssignment