import React from 'react'
import { useState, useEffect } from 'react';
import Select from '../Select';
import AdminUnitTestFields from './AdminUnitTestFields';

function AdminUnitTest({type}) {
    const newUnitTest = {id:999999, unitTest:'', secretUnitTest:'', unitTestMethod:'', startCode:'', compileTest:'', assignmentID:999999, languageID:999999}
    const [unitTest, setUnitTest] = useState();
    const [unitTests, setUnitTests] = useState([]);
    const [assignments, setAssignments] = useState([]);
    const [languages, setLanguages] = useState([]);

	const handleUpdateUT = (e) => {
		if(e.target.value == undefined){
			setUnitTest({})
		}
		setUnitTest( {...unitTests.find( a => a.id == e.target.value)} );
	}
    useEffect(()=> { 
        fetch('http://localhost:5291/api/Language')
            .then((res) => res.json())
            .then((data) => {
            	setLanguages(data.data); 
			})
			} ,[])
    useEffect(()=> { 
        fetch('http://localhost:5291/api/assignment')
            .then((res) => res.json())
            .then((data) => {
            	setAssignments(data.data); 
			})
			} ,[])

    useEffect(()=> { 
        fetch('http://localhost:5291/api/UnitTest')
            .then((res) => res.json())
            .then((data) => {
					var nameData = data.data
					nameData.forEach(e => {
						e.name = e.assignmentID + "-" + e.languageID 
					});
            	setUnitTests(nameData); 
				setUnitTest(nameData[0]);
			})
			} ,[])

    useEffect( () => {
		console.log(unitTest);
    }, [unitTest] )

	function renderByType(){
		if(type == "new" && (unitTest == undefined || unitTest.id != 999999 )){
			setUnitTest(newUnitTest);
		}
		if(type == "update"){
			if(unitTest != undefined && unitTest.id == 999999){
				setUnitTest(unitTests[0])
			}
			return (
				<>
					<Select list={unitTests} handler={handleUpdateUT}/>
					{unitTest!=undefined  && <AdminUnitTestFields unitTest={unitTest} handler={setUnitTest} type={type}/>}
				</>
			)
		}else if(type == "new"){
			return(<AdminUnitTestFields assignments={assignments} languages={languages} unitTest={unitTest} handler={setUnitTest} type={type}/>)
		}
	}
  return (
    <div className='admin-right-container'> 
		{renderByType()}
    </div>
  )
}

export default AdminUnitTest;