import React, { useState } from 'react'
import Utils from '../utils/Utils'


function Assignment( { orphanTest, filteredList, handler } ) {
	
	function mapDifficulty(difficulty){
		switch(difficulty){
			case 0:
				return "Basic"
			case 1:
				return "Intermediate" 
			case 2:
				return "Advanced"
			case 3:
				return "Expert"
			default:
				return ""
		}
	}
  return (
	<div>
		{filteredList.map(a => {
			return (
				<div key={a.id} className={filteredList.findIndex(x => x.id == a.id)%2==1?'tests-assignment-container':'tests-assignment-container-2'} onClick={() => handler(a)}>
					<div className='tests-assignment-name'>{a.name}</div> 
						<div className='tests-assignment-progress-bar'>
							<div className={'tests-assignment-progress-'+Utils.mapProgress(a, orphanTest)}>

							</div>
						</div>
					<div className={'tests-assignment-difficulty-'+a.difficulty}>{mapDifficulty(a.difficulty)}</div> 
				</div>

			)
		})}
	</div>
  )
}

export default Assignment