import React, { useState, useEffect } from "react";
import Editor, { Monaco, ControlledEdti, useMonaco, loader } from "@monaco-editor/react";


const options = {
	minimap: { enabled: false },
};

const CodeEditorWindow = ({ onChange, language, code, theme, height, width, info, defaultValue, value }) => {
	function setEditorTheme(monaco) {
		monaco.editor.defineTheme('onedark', {
		  base: 'vs-dark',
		  inherit: true,
		  rules: [
			{
			  token: 'comment',
			  foreground: '#5d7988',
			},
			{ token: 'constant', foreground: '#e06c75' }
		  ],
		  colors: {
			'editor.background': '#2D3741'
		  }
		});
	  }


	return (
		<div className="editor-container">
			<div className="editor-header">{info}</div>
			<Editor
				height={height}
				width={width}
				language={language || "javascript"}
				value={value}
				theme={theme}
				defaultValue={defaultValue}
				onChange={onChange}
				theme="onedark"
				options={options}
				beforeMount={setEditorTheme}
			/>
		</div>
	);
};

export default CodeEditorWindow;
