import React, { useState } from "react";
import { useNavigate } from 'react-router-dom';
import headercss from "../styles/header.css";
import logo from "../resources/logo.png";
import adminwhite from "../resources/admin-white.svg"
import adminblue from "../resources/admin-blue.svg"
import codewhite from "../resources/code-white.svg"
import codeblue from "../resources/code-blue.svg"
import logout from "../resources/logout.svg"
import userwhite from "../resources/user-white.svg"
import userblue from "../resources/user-blue.svg"

export default function Header({ handler }) {
	const [marked, setMarked] = useState("home")
	const navigate = useNavigate();

	function handleMark(icon){
		if(icon == "logout"){
			handler({name:"",set:false})
			setMarked(icon)
			navigate("/")
		}else if(icon == "home"){
			window.location.href = "https://wa.works/";
		}
		else{
			setMarked(icon)
			navigate("/"+icon)
		}
	}
	return (
		<div className="header-container">
			<div className="header-button-container">
				<div className="header-button" onClick={() => handleMark("home")}>
					<img className="header-logo" src={logo} draggable="false" />
				</div>
			</div>
			<div className="header-button-container">
				<div className="header-button" onClick={() => handleMark("test")}>
					<img src={marked=="test"?codewhite:codeblue} draggable="false"/>
				</div>
				<div className="header-button" onClick={() => handleMark("user")}>
					<img src={marked=="user"?userwhite:userblue} draggable="false"/>
				</div>
				<div className="header-button" onClick={() => handleMark("admin")}>
					<img src={marked=="admin"?adminwhite:adminblue} draggable="false"/>
				</div>
			</div>
			<div className="header-button-container">
				<div className="header-button" onClick={() => handleMark("logout")}>
					<img src={logout} draggable="false"/>
				</div>
			</div>
		</div>
	);
}
