function convertToAssignmentRequest(assignment) {
    const assignmentRequest = {}
    assignmentRequest.id = assignment.id;
    assignmentRequest.name = assignment.name;
    assignmentRequest.description = assignment.description;
    assignmentRequest.difficulty = assignment.difficulty;
    assignmentRequest.released = assignment.released;
    assignmentRequest.released = assignment.released;
    assignmentRequest.languages = [];
    if (assignment.languages != null || assignment.languages != undefined || assignment.languages != []) {
        assignmentRequest.languages = assignment.languages.map( o => o.id )
    }
    console.log(assignmentRequest);
    return assignmentRequest;
}
async function postAssignment(assignment) {
    delete assignment.id;
    const resp = await fetch("http://localhost:5291/api/Assignment",
        {method:"POST", 
        body:JSON.stringify(convertToAssignmentRequest(assignment)),
        headers:{ "Content-Type":"application/json", "Accept":"*/*" }
    })
        .then((res) => res.json())
        .then((data) => {
            console.log("post:");
            console.log(data);
            return data;
    });
    return resp;
}
async function putAssignment(assignment) {
    var request = convertToAssignmentRequest(assignment);
    const resp = await fetch("http://localhost:5291/api/Assignment/"+assignment.id,
    {method:"PUT",
        body:JSON.stringify(request),
        headers:{ "Content-Type":"application/json", "Accept":"*/*" }
    })
        .then((res) => res.json())
        .then((data) => {
            console.log("put:");
            console.log(data);
            return data;
        })
    return resp;
}
async function deleteAssignment(assignment) {
    const resp = await fetch("http://localhost:5291/api/Assignment/"+assignment.id,
        {method:"DELETE", headers:{"Accept":"*/*"}})
        .then((res) => res.json())
        .then((data) => {
            console.log("delete:");
            console.log(data);
            return data;
        })
    return resp;
}
async function getDetailedAssignment(assignment) {
    const resp = await fetch("http://localhost:5291/api/Assignment/"+assignment.id,
        {method:"GET", headers:{ "Content-Type":"application/json", "Accept":"*/*" }})
        .then((res) => res.json())
        .then((data) => {
            console.log("delete:");
            console.log(data);
            return data;
        })
    return resp;
}

export default { postAssignment, putAssignment, deleteAssignment, convertToAssignmentRequest, getDetailedAssignment }