async function checkIfUserHasTest(name){
    var out = await fetchOrphanTestByUserName(name).valueOf();
    return out.data.length > 0;
}
async function checkIfAssignmentInOrphan(name, assignmentID){
    var out = await fetchOrphanTestByUserName(name).valueOf();
    out = out.data[0].userAssignments
    out = out.filter(x => x.assignmentID == assignmentID)
    out = out.length > 0;
    return out;
}

async function postUserAssignment(testID, assignmentID){
    const args = {
        "testID": testID,
        "test": null,
        "assignmentID": assignmentID,
        "assignment": null,
        "attempts": [],
        "submissionID": 0,
        "created": new Date().toJSON() 
    }
    const resp = await fetch("http://localhost:5291/api/UserAssignment",
        {method:"POST", 
        headers:{ "Content-Type":"application/json", "Accept":"*/*" },
        body:JSON.stringify(args),
    })
        .then((res) => res.json())
        .then((data) => {
            console.log("post:");
            console.log(data);
            if(data.status == 1){
                return data;
            }
            return data;
    });
    return resp
}

async function fetchOrphanTestByUserName(name){
    const resp = await fetch("http://localhost:5291/api/test",
        {method:"GET", 
        headers:{ "Content-Type":"application/json", "Accept":"*/*" }
    })
        .then((res) => res.json())
        .then((data) => {
            if(data.status == 1){
                //this get all test, not ideal. fix a new endpoint in api or relogic the api endpoint.
                console.log("get:");
                console.log(data.data);
                data.data = data.data.filter(x => x.user == name);
                return data;
            }
            return data;
    });
    return resp;
}
async function fetchUserAssignmentByTest(testID){
    const resp = await fetch("http://localhost:5291/api/UserAssignment",
        {method:"GET", 
        headers:{ "Content-Type":"application/json", "Accept":"*/*" }
    })
        .then((res) => res.json())
        .then((data) => {
            console.log("get:");
            console.log(data);
            if(data.status == 1){
                //this get all userAssignments, not ideal. fix a new endpoint in api or relogic the api endpoint.
                data.data.filter(x => x.testID == testID);
                return data;
            }
            return data;
    });
    return resp;
}

//all users only have one orphan test with all their 
//attempted assignments.
async function postOrphanTest(name){
    const args = {
    "testID": 0,
    "testTypeId": 0,
    "user": name,
    "owner": null,
    "link": null,
    "assingmentIDs": [],
    "testTypeID": 0
    }
    const resp = await fetch("http://localhost:5291/api/test",
        {method:"POST", 
        body:JSON.stringify(args),
        headers:{ "Content-Type":"application/json", "Accept":"*/*" }
    })
        .then((res) => res.json())
        .then((data) => {
            console.log("post:");
            console.log(data);
            return data;
    });
    return resp;
}
export default { fetchUserAssignmentByTest,postOrphanTest, postUserAssignment, checkIfAssignmentInOrphan, checkIfUserHasTest, fetchOrphanTestByUserName}