import React from 'react'
import { useState, useEffect, useRef } from 'react';
import Select from '../components/Select';
import AdminAssignment from '../components/Admin/AdminAssignment';
import AdminUnitTest from '../components/Admin/AdminUnitTest';

function AdminView() {
    const [options, setOptions] = useState([{id:0,name:"Edit Assignment"}, {id:1,name:"New Assignment"}, {id:4, name:"Edit UnitTest"},{id:5,name:"New UnitTest"},]);
    const [option, setOption] = useState({id:0,name:"Edit Assignment"});
    function returnComponentByOption(){
        if(option==undefined){
            return
        }
        console.log(option.id);
        switch(option.id){
            case 0:
                return (<AdminAssignment type="update" />)
            break;
            case 1:
                return (<AdminAssignment type="new" />)
            break;
            case 4:
                return (<AdminUnitTest type="update" />)
            break;
            case 5:
                return (<AdminUnitTest type="new" />)
            break;
        }
    }
    useEffect( () => {
		console.log(option);
    }, [option] )

    function handleUpdate(id) {
        const newObj = {...options.find( a => a.id == id)};
        setOption(newObj)
    }
	return (
		<div className='admin-container'>
			<div className='admin-header'>
                {options.map(x => {
                    return(
                        <div className='admin-container-btn' onClick={() => handleUpdate(x.id)}>
                            {x.name}
                        </div>
                    )
                })}
			</div>
            <div className='admin-container-bottom'>
            <div className='admin-left-container'>
            </div>
            {returnComponentByOption()}
			</div>
		</div>
	)
}

export default AdminView