import React, { useState, useEffect } from 'react'
import Assignment from '../components/Assignment';
import testsutils from '../utils/testUtils'
import { useNavigate } from 'react-router-dom';
import AdminInput from '../components/Admin/AdminInput'
import UserUtils from '../utils/UserUtils';
import Filter from '../components/Filter';



function TestsView( { name }) {
	const navigate = useNavigate();
	const [assignments, setAssignments] = useState([]);
	const[listFiltered, setFilteredList] = useState([])
	const[orphanTest, setOrphanTest] = useState({});
	useEffect(() => {
		UserUtils.fetchOrphanTestByUserName(name).then((data) => {
			if(data.status == 1){
				console.log(data.data);
				if(data.data.length>0){
					setOrphanTest(data.data[0])
				}
			}
		}
		)
		
	}, [])
	useEffect(() => {
		fetch('http://localhost:5291/api/assignment')
			.then((res) => res.json())
			.then((data) => {
				if (data.data) {
					setAssignments(data.data);
					setFilteredList(data.data)
				}
			})
	}, [])
	function selectAssignment(assignment) {
		console.log(assignment);
		navigate("/assignment", { state: assignment })
		//testsutils.postTest(name); //with user name, get back id for test
		//testsutils.postUserAssignment(); //with assignment, language and testid
		//redirect to testView with userAssignment. 
	}
	return (
		<div className='tests-container'>
			<div className='tests-header'>
				<h1>
					Select your test of poison!
				</h1>
			</div>
			<div className='tests-split'>
				<div className='tests-filter'>
					<div className='tests-container-header'>
						Filter
					</div>
					<Filter orphanTest={orphanTest} assignments={assignments} handler={setFilteredList}/>
				</div>
				<div className='tests-list'>
					<div className='tests-container-header'>
						Tests
					</div>
					<Assignment orphanTest={orphanTest} filteredList={listFiltered} handler={selectAssignment} />
				</div>
			</div>
		</div>
	)
}

export default TestsView;